const path = require('path')
const webpack = require('webpack')
const MiniCssExtractPlugin = require('mini-css-extract-plugin')
const { CleanWebpackPlugin } = require('clean-webpack-plugin')
const OptimizeCSSAssetsPlugin = require('optimize-css-assets-webpack-plugin')
const CircularDependencyPlugin = require('circular-dependency-plugin')
const TerserPlugin = require('terser-webpack-plugin')
const CopyWebpackPlugin = require('copy-webpack-plugin')
const autoprefixer = require('autoprefixer')
const ForkTsCheckerWebpackPlugin = require('fork-ts-checker-webpack-plugin')
const CaseSensitivePathsPlugin = require('case-sensitive-paths-webpack-plugin')
const fs = require('fs')
const { StreamInfo, BundleToFunction } = require('./plugins')

const getEnv = () => (process.env.NODE_ENV || 'production').toLowerCase()

const scssDtsBanner = `
/* eslint-disable */
// prettier-ignore
// This file is automatically generated by typings-for-css-modules.
// Don't change it directly!
`

// META_MODE values: none all only_map only_dts
const getMetaMode = () => (process.env.META_MODE || 'none').toLowerCase()
const skipTypeChecking = process.env.TYPE_CHECK === 'skip'
const defaultDictionariesPath = path.resolve(__dirname, '../../../../dictionaries')

const getDefaultConfig = (options = {}) => {
  const env = options.env || getEnv()
  if (env !== 'production' && env !== 'development') {
    throw new Error(`Unknown env ${env}`)
  }

  const isProduction = env === 'production'
  const genDts = getMetaMode() === 'all' || getMetaMode() === 'only_dts'
  const genMap = getMetaMode() === 'all' || getMetaMode() === 'only_map'

  let uglifyExtraOptions = {}
  const target = options.target === undefined ? 'web' : options.target
  if (options.uglifyOptimizationInline !== undefined) {
    uglifyExtraOptions.compress = {
      // (false) Фикс для MaskedInput - при билде валилась ошибка Super expression must either be null or a function, not undefined
      inline: options.uglifyOptimizationInline,
    }
  }
  const sourceMap = options.sourceMap === undefined ? genMap : options.sourceMap
  const externals = options.externals || []
  const plugins = options.plugins || []
  // Если в node_modules, сделай три шага вверх из node_modules/@platform/tools
  const entry = path.resolve(
    __dirname,
    (__dirname.indexOf('node_modules') !== -1 ? '../../../../' : '') + (options.entry || 'src/index.tsx')
  )
  const distFolder = options.outputFolder || './dist'
  /**
   * Папка для генерации тайпингов
   */
  const typesFolder = options.typesFolder
  const allowTsInNodeModules = options.allowTsInNodeModules || false
  const disableWrappingOfModuleToFunc = options.disableWrappingOfModuleToFunc || false
  const generateDts = options.generateDts === undefined ? genDts : options.generateDts
  const libraryTarget = options.libraryTarget || 'umd'
  const cleanWebpackPluginOptions = options.cleanWebpackPluginOptions
  const defaultResourcesPath = options.module ? `/streams/${options.module}` : undefined
  const resourcesPath = options.resourcesPath === undefined ? defaultResourcesPath : options.resourcesPath

  /** Для задания произвольного имени tsconfig. */
  const configFile = options.ts || 'tsconfig.json'
  /** Для задания произвольного пути до dictionaries. */
  const dictionariesPath = options.dictionaries || defaultDictionariesPath

  return {
    mode: env,
    entry,
    target,
    externals: Array.isArray(externals) ? externals : [externals],
    output: {
      filename: 'index.js',
      path: path.resolve(distFolder),
      publicPath: '/',
      ...(options.module
        ? {
            libraryTarget: libraryTarget,
            library: options.module,
            umdNamedDefine: true,
          }
        : {}),
    },
    resolve: {
      extensions: ['.ts', '.tsx', '.js', '.json'],
      modules: ['src', 'node_modules'],
      symlinks: false,
    },
    module: {
      rules: [
        ...(options.rules || []),
        {
          test: /\.svg$/,
          use: {
            loader: 'svg-react-loader',
            options: {
              tag: 'svg',
              name: 'Icon',
            },
          },
        },
        {
          test: /\.tsx?$/,
          use: {
            loader: `ts-loader?allowTsInNodeModules=${allowTsInNodeModules}`,
            options: {
              transpileOnly: !generateDts,
              onlyCompileBundledFiles: true,
              compilerOptions: {
                outDir: path.resolve(...(typesFolder ? [typesFolder] : [distFolder, './dist-types'])),
              },
              configFile,
            },
          },
        },
        {
          test: /\.scss$/,
          use: [
            MiniCssExtractPlugin.loader,
            {
              loader: '@teamsupercell/typings-for-css-modules-loader',
              options: {
                banner: scssDtsBanner,
              },
            },
            {
              loader: 'css-loader',
              options: {
                sourceMap,
                modules: {
                  localIdentName: isProduction ? '[hash:base64:5]' : '[name]__[local]--[hash:base64:5]',
                },
              },
            },
            {
              loader: 'postcss-loader',
              options: {
                plugins: [
                  autoprefixer({
                    overrideBrowserslist: ['ie >= 10', 'last 4 version'],
                    grid: 'autoplace',
                  }),
                ],
                sourceMap,
              },
            },
            {
              loader: 'resolve-url-loader',
            },
            {
              loader: 'sass-loader',
              options: {
                sourceMap: true, // без этого true не работает погрузка шрифтов НЕ УДАЛЯТЬ
              },
            },
          ],
        },
        {
          test: /\.css$/,
          use: [
            MiniCssExtractPlugin.loader,
            {
              loader: 'css-loader',
            },
          ],
        },
        {
          test: /\.(eot|ttf|woff|woff2|png|jpg|docx|pdf)$/,
          loader: 'file-loader',
          options: {
            name: `./resources/[name].[ext]`,
            publicPath: resourcesPath,
          },
        },
      ],
    },
    devtool: 'source-map',
    optimization: {
      minimizer: [
        new TerserPlugin({
          sourceMap,
          extractComments: false,
          terserOptions: {
            output: {
              comments: false,
            },
            ...uglifyExtraOptions,
          },
        }),
        new OptimizeCSSAssetsPlugin({
          // Процессор CSS, используемый для оптимизации \ минимизации CSS
          cssProcessor: require('cssnano'),
          // Параметры, переданные в cssProcessor
          cssProcessorOptions: {
            // Удаляем комментарии внутри и вокруг правил, селекторов и деклараций.
            // Обратите внимание, что любые специальные комментарии отмечены "!" сохраняются по умолчанию.
            discardComments: { removeAll: true },
            // Убираем нормализацию строки URL
            normalizeUrl: false,
            zindex: false,
          },
        }),
      ],
    },
    plugins: [
      new CaseSensitivePathsPlugin(),
      new CleanWebpackPlugin(cleanWebpackPluginOptions),
      ...(generateDts || skipTypeChecking
        ? []
        : [
            new ForkTsCheckerWebpackPlugin({
              reportFiles: ['!node_modules/**/*.{ts,tsx}'],
              memoryLimit: 4096,
            }),
          ]),
      ...(options.module && !disableWrappingOfModuleToFunc
        ? [
            new BundleToFunction({
              moduleName: options.module,
              isDev: getEnv() === 'development',
            }),
          ]
        : []),
      new StreamInfo({ dictionariesPath }),
      new MiniCssExtractPlugin({
        filename: 'index.css',
        chunkFilename: '[id].css',
      }),
      new webpack.DefinePlugin({
        'process.env.NODE_ENV': JSON.stringify(env),
      }),
      new CircularDependencyPlugin({
        exclude: /node_modules/,
        // add errors to webpack instead of warnings
        failOnError: true,
        // set the current working directory for displaying module paths
        cwd: process.cwd(),
      }),
      ...(fs.existsSync(dictionariesPath) ? [new CopyWebpackPlugin([{ from: dictionariesPath }])] : []),
      ...plugins,
    ],
  }
}

module.exports = {
  getDefaultConfig,
  getEnv,
}
